=== added file '.project'
--- .project	1970-01-01 00:00:00 +0000
+++ .project	2011-03-28 12:00:05 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>UF-168: Multi-Currency</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.python.pydev.PyDevBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.python.pydev.pythonNature</nature>
+	</natures>
+</projectDescription>

=== added file '.pydevproject'
--- .pydevproject	1970-01-01 00:00:00 +0000
+++ .pydevproject	2011-03-28 12:00:05 +0000
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<?eclipse-pydev version="1.0"?>
+
+<pydev_project>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_INTERPRETER">Default</pydev_property>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_VERSION">python 2.6</pydev_property>
+</pydev_project>

=== added directory 'res_currency_functional'
=== added file 'res_currency_functional/__init__.py'
--- res_currency_functional/__init__.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/__init__.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,27 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+
+import res_currency_functional
+import res_currency_rate_functional
+import account_move_line_compute_currency
+import wizard
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'res_currency_functional/__openerp__.py'
--- res_currency_functional/__openerp__.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/__openerp__.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,40 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+{
+    "name": "Multi-Currency Management",
+    "version": "1.0",
+    "depends": ["base", "account"],
+    "category": "General/Standard",
+    "description": """
+    This module aims to only use a subset of currencies, and have them available
+    for each accounting entry.
+    
+    """,
+    "init_xml": [],
+    'update_xml': [
+        'res_currency_functional_view.xml',
+    ],
+    'demo_xml': [],
+    'installable': True,
+    'active': False,
+#    'certificate': 'certificate',
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'res_currency_functional/account_move_line_compute_currency.py'
--- res_currency_functional/account_move_line_compute_currency.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/account_move_line_compute_currency.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,68 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+import decimal_precision as dp
+
+class account_move_line_compute_currency(osv.osv):
+    _inherit = "account.move.line"
+    
+    def refresh_rate(self, cr, uid, ids):
+        for move_line in self.browse(cr, uid, ids):
+            cur_obj = self.pool.get('res.currency')
+            account_obj = self.pool.get('account.account')
+            account = account_obj.browse(cr, uid, move_line.account_id.id)
+            ctx = {}
+            if move_line.date:
+                ctx['date'] = move_line.date
+            if move_line.debit_currency != 0.0 or move_line.credit_currency != 0.0:
+                # Booking currency used for debit/credit;
+                # they are converted to the functional currency
+                debit_computed = cur_obj.compute(cr, uid, move_line.currency_id.id,
+                    move_line.functional_currency_id.id, move_line.debit_currency, round=False, context=ctx)
+                credit_computed = cur_obj.compute(cr, uid, move_line.currency_id.id,
+                    move_line.functional_currency_id.id, move_line.credit_currency, round=False, context=ctx)
+                cr.execute('update account_move_line set debit=%s, credit=%s where id=%s', (debit_computed, credit_computed, move_line.id))
+    
+
+    def create(self, cr, uid, vals, context={}):
+        res_id = super(account_move_line_compute_currency, self).create(cr, uid, vals, context)
+        self.refresh_rate(cr, uid, [res_id])
+        return res_id
+    
+    def write(self, cr, uid, ids, vals, context=None, check=True, update_check=True):
+        res = super(account_move_line_compute_currency, self).write(cr, uid, ids, vals, context, check, update_check)
+        self.refresh_rate(cr, uid, ids)
+        return res
+    
+    _columns = {
+        'debit_currency': fields.float('Booking Out', digits_compute=dp.get_precision('Account')),
+        'credit_currency': fields.float('Booking In', digits_compute=dp.get_precision('Account')),
+        'functional_currency_id': fields.related('account_id', 'company_id', 'currency_id', type="many2one", relation="res.currency", string="Functional Currency", store=False),
+    }
+    
+    _defaults = {
+        'debit_currency': 0.0,
+        'credit_currency': 0.0,
+    }
+    
+account_move_line_compute_currency()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'res_currency_functional/res_currency_functional.py'
--- res_currency_functional/res_currency_functional.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/res_currency_functional.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,39 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+
+class res_currency_functional(osv.osv):
+    _inherit = 'res.currency'
+    
+    _columns = {
+        'k_currency_active': fields.boolean('Activate K-currency?'),
+        'k_currency': fields.integer('K-currency'),
+    }
+
+    _defaults = {
+        'accuracy': 4, 
+        'k_currency_active': False,
+        'k_currency': 1,
+    }
+    
+res_currency_functional()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'res_currency_functional/res_currency_functional_view.xml'
--- res_currency_functional/res_currency_functional_view.xml	1970-01-01 00:00:00 +0000
+++ res_currency_functional/res_currency_functional_view.xml	2011-03-28 12:00:05 +0000
@@ -0,0 +1,103 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+
+        <record id="view_currency_functional_tree" model="ir.ui.view">
+            <field name="name">res.currency_functional.tree</field>
+            <field name="model">res.currency</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="base.view_currency_tree"/>
+            <field name="arch" type="xml">
+                <tree string="Currencies" position="replace">
+                    <tree string="Currencies">
+	                    <field name="name"/>
+                        <field name="rate"/>
+                        <field name="date"/>
+	                    <field name="rounding"/>
+                        <field name="active"/>
+                        <field name="k_currency_active"/>
+                        <field name="k_currency"/>
+	                </tree>
+	            </tree>
+            </field>
+        </record>
+        
+        <record id="view_currency_functional_form" model="ir.ui.view">
+            <field name="name">res.currency_functional.form</field>
+            <field name="model">res.currency</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="base.view_currency_form"/>
+            <field name="arch" type="xml">
+                <data>
+                    <field name="company_id" position="replace"/>
+                    <field name="accuracy" position="replace">
+                        <field name="k_currency_active"/>
+                        <field name="k_currency"/>
+                    </field>
+                </data>
+            </field>
+        </record>
+        
+         <record id="view_currency_functional_search" model="ir.ui.view">
+            <field name="name">res.currency_functional.search</field>
+            <field name="model">res.currency</field>
+            <field name="type">search</field>
+            <field name="arch" type="xml">
+                <search string="Currencies">
+                    <group>
+                        <filter name="active" icon="terp-check" string="Active" domain="[('active','=','true')]"/>
+	                    <separator orientation="vertical"/>
+	                    <field name="name"/>
+                    </group>
+                </search>
+            </field>
+        </record>
+        
+        <record id="action_currency_functional_form" model="ir.actions.act_window">
+            <field name="name">Currencies</field>
+            <field name="res_model">res.currency</field>
+            <field name="inherit_id" ref="base.action_currency_form"/>
+            <field name="search_view_id" ref="view_currency_functional_search"/>
+            <field name="view_id" ref="view_currency_functional_tree"/>
+            <field name="context">{'active_test': False, 'search_default_active': 1}</field>
+        </record>
+        
+        <menuitem action="action_currency_functional_form" id="base.menu_action_currency_form" parent="account.menu_configuration_misc"/>
+        
+        
+        <!--Account Move lines-->
+        <record id="activate_currencies_view" model="ir.ui.view">
+            <field name="name">Activate/Deactivate Currencies</field>
+            <field name="model">activate.currencies</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+            <form string="Activate/Deactivate Currencies">
+                <field name="active_status"/>
+                <button icon="gtk-cancel" special="cancel" string="Cancel"/>
+                <button icon="terp-camera_test" string="Approve" name="change_currency_status" type="object" default_focus="1"/>
+            </form>
+            </field>
+        </record>
+
+        <record id="action_activate_currencies" model="ir.actions.act_window">
+            <field name="name">Activate/Deactivate Currencies</field>
+            <field name="type">ir.actions.act_window</field>
+            <field name="res_model">activate.currencies</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">form</field>
+            <field name="view_id" ref="activate_currencies_view"/>
+            <field name="target">new</field>
+        </record>
+
+        <record model="ir.values" id="activate_currencies_values">
+            <field name="model_id" ref="base.model_res_currency" />
+            <field name="object" eval="1" />
+            <field name="name">Activate/Deactivate Currencies</field>
+            <field name="key2">client_action_multi</field>
+            <field name="value" eval="'ir.actions.act_window,' + str(ref('action_activate_currencies'))" />
+            <field name="key">action</field>
+            <field name="model">res.currency</field>
+        </record>
+        
+    </data>
+</openerp>
\ No newline at end of file

=== added file 'res_currency_functional/res_currency_rate_functional.py'
--- res_currency_functional/res_currency_rate_functional.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/res_currency_rate_functional.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,68 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+
+from osv import fields, osv
+
+
+class res_currency_rate_functional(osv.osv):
+    _inherit = "res.currency.rate"
+    
+    def refresh_move_lines(self, cr, uid, ids, date=None, currency=None):
+        cur_obj = self.pool.get('res.currency')
+        account_obj = self.pool.get('account.account')
+        move_line_obj = self.pool.get('account.move.line')
+        if currency is None:
+            currency_obj = self.read(cr, uid, ids, ['currency_id'])[0]
+            currency = currency_obj['currency_id'][0]
+        move_line_search_params = [('currency_id', '=', currency)]
+        if date is not None:
+            move_line_search_params.append(('date', '>=', date))
+        
+        move_line_ids = move_line_obj.search(cr, uid, move_line_search_params)
+        move_line_obj.refresh_rate(cr, uid, move_line_ids)
+    
+    def create(self, cr, uid, vals, context=None):
+        # This method is used to re-compute all account move lines
+        # when a currency is modified
+        res_id = super(res_currency_rate_functional, self).create(cr, uid, vals, context)
+        self.refresh_move_lines(cr, uid, [res_id], date=vals['name'])
+        return res_id
+    
+    def write(self, cr, uid, ids, vals, context=None):
+        # This method is used to re-compute all account move lines
+        # when a currency is modified
+        res = super(res_currency_rate_functional, self).write(cr, uid, ids, vals, context)
+        self.refresh_move_lines(cr, uid, ids, date=vals['name'])
+        return res
+    
+    def unlink(self, cr, uid, ids, context=None):
+        # This method is used to re-compute all account move lines
+        # when a currency is modified
+        currency_obj = self.read(cr, uid, ids, ['currency_id'])[0]
+        currency = currency_obj['currency_id'][0]
+        res = super(res_currency_rate_functional, self).unlink(cr, uid, ids, context)
+        self.refresh_move_lines(cr, uid, ids, currency=currency)
+        return res
+    
+
+res_currency_rate_functional()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added directory 'res_currency_functional/wizard'
=== added file 'res_currency_functional/wizard/__init__.py'
--- res_currency_functional/wizard/__init__.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/wizard/__init__.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+
+import activate_currencies
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'res_currency_functional/wizard/activate_currencies.py'
--- res_currency_functional/wizard/activate_currencies.py	1970-01-01 00:00:00 +0000
+++ res_currency_functional/wizard/activate_currencies.py	2011-03-28 12:00:05 +0000
@@ -0,0 +1,44 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+
+class activate_currencies(osv.osv):
+    _name = "activate.currencies"
+    
+    _columns = {
+        'active_status': fields.boolean('Set selected currencies as active')
+    }
+    
+    _defaults = {
+        'active_status': True
+    }
+    
+    def change_currency_status(self, cr, uid, ids, context=None):
+        
+        currency_obj = self.pool.get('res.currency')
+        data = self.read(cr, uid, ids, [], context=context)[0]
+        for currency_id in context['active_ids']:
+            cr.execute('update res_currency set active=%s where id=%s',(data['active_status'],currency_id))
+        return {'type': 'ir.actions.act_window_close'}
+    
+activate_currencies()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

